#include "odf.c"

void formate(ODF_FILE *odf){
	int c;

	odf_addPercentageFormat(odf,2,0,1);
	odf_addNumberFormat(odf,3,1,1," Erl");
	for(c=1;c<5;c++) odf_addColFormat(odf,c,(double) 3+(double)c/2);
	for(c=1;c<5;c++) odf_addRowFormat(odf,c,(double) 0.5+(double) c/6);


	/* die Zellformate vorbereiten */
	cellStyle.h_margin=2;
	cellStyle.vert_align=VA_MIDDLE;
	cellStyle.horz_align=HO_CENTER;
	setBorder(BM_ALL,BS_SOLID,0.5,0x00007f);
	setBorder(BM_BOTTOM,BS_DOUBLE,1.0,0x00007f);
	cellStyle.text_color=0x7f0000;
	cellStyle.bg_color=0xf0f0f0;
	cellStyle.text_size=12;
	cellStyle.text_styles=TS_BOLD;
	strcpy(cellStyle.font_name,"Arial");
	add_cellStyle(odf,1);	/* Zellformat 1 für Spaltenköpfe */

	setBorder(BM_ALL,BS_SOLID,0.5,0x00007f);
	setBorder(BM_TOP,BS_NONE,0.0,0x000000);
	cellStyle.text_color=0x007f00;
	cellStyle.text_size=10;
	cellStyle.text_styles=TS_ITALIC;
	strcpy(cellStyle.font_name,"Times New Roman");
	cellStyle.bg_color=0xffffff;
	cellStyle.horz_align=HO_LEFT;

	for(c=2;c<20;c++){
		cellStyle.text_size=4+c;
		add_cellStyle(odf,c);
	}
	cellStyle.horz_align=HO_RIGHT;
	cellStyle.text_color=0x1f0000;
	cellStyle.text_size=8;
	add_cellStyle(odf,20);
	cellStyle.data_style=2;
	add_cellStyle(odf,21);
	cellStyle.data_style=3;
	add_cellStyle(odf,22);

	odf_addParagraphStyle(odf,1,10,CF_LEFT,100);
	odf_addParagraphStyle(odf,2,11,CF_CENTER,100);
	odf_addParagraphStyle(odf,3,12,CF_RIGHT,100);
	odf_addParagraphStyle(odf,4,13,CF_CENTER|TS_BOLD,150);
	odf_addParagraphStyle(odf,5,14,CF_CENTER|TS_ITALIC,150);
	odf_addParagraphStyle(odf,6,15,CF_CENTER|TS_BOLD|TS_ITALIC,150);
	odf_addParagraphStyle(odf,7,16,CF_LEFT,100);
	odf_addParagraphStyle(odf,8,17,CF_LEFT,100);
	odf_addParagraphStyle(odf,9,18,CF_LEFT,100);
	odf_addParagraphStyle(odf,10,19,CF_LEFT,100);
	odf_addParagraphStyle(odf,11,20,CF_LEFT,100);
	odf_addParagraphStyle(odf,12,22,CF_LEFT,100);

}

int main(int argc, char **argv){
	ODF_FILE *odf;
	int r=0,c=0,p=0;
	double d;
	char st[100];

	odf=odf_open("test.ods",ODF_CALC);
	odf_addMeta(odf,"dc:creator","Wendler, Ingo");
	odf_addFont(odf,"Arial");
	odf_addFont(odf,"Times New Roman");
	odf_endFonts(odf);
	/* allgemeine Formate */
	formate(odf);
	/* Calc spezifische Formate */

	odf_endAutoStyles(odf);	/* ab hier beginnt der Body */
	ods_startSheet(odf);
	for(p=0;p<2;p++){
		sprintf(st,"Blatt %d",p);
		odf_startTable(odf,st,0);
		for(c=0;c<4;c++) odf_Column(odf,c+1,0);
		odf_ColumnGroup(odf,1,4,0);
		odf_startRow(odf,r);
		for(c=0;c<8;c++){
			sprintf(st,"Head%d",c+1);
			odf_writeCell(odf,st,1,1);
		}
			odf_endRow(odf);
		for(r=0;r<10;r++){
			odf_startRow(odf,r);
			for(c=0;c<8;c++){
				sprintf(st,"P%d C%d R%d",p,c,r);
				odf_writeCell(odf,st,r+2,0);	/* cellStyle, paragraphStyle */
			}
			odf_endRow(odf);
		}
		//for(r=0;r<50;r++) my_rnd();
		for(r=0;r<18;r++){
			my_rnd();
			d=(double) rnd_value/1000000000;
			odf_startRow(odf,1);
			odf_writeDoubleCell(odf,d,22,r);
			odf_writePercent2Cell(odf,d,20);
			odf_writePercent0Cell(odf,d,21);
			odf_writeIntCell(odf,rnd_value,20);
			odf_endRow(odf);
		}
	odf_endTable(odf);
	}
	ods_endSheet(odf);
	if(odf) odf_close(odf);

	odf=odf_open("test.odt",ODF_TEXT);
	odf_addMeta(odf,"dc:creator","Wendler, Ingo");
	odf_addFont(odf,"Arial");
	odf_addFont(odf,"Times New Roman");
	odf_endFonts(odf);
	/* allgemeine Formate */
	formate(odf);
	/* textspezifische Formate */
	odf_addTableFormat(odf,1,12);

	odf_endAutoStyles(odf);
	odt_startDoc(odf);
	for(c=1;c<7;c++){
		sprintf(st,"Zeile%d",c);
		odf_writeParagraph(odf,st,c);
	}
	odf_writeParagraph(odf,"",1);
	/* jetzt noch eine Tabelle */
	odf_startTable(odf,"Tab1",1);
	odf_startColumns(odf);
	for(c=0;c<3;c++) odf_Column(odf,c+1,0);
	odf_endColumns(odf);
	odtStartTableHeaderRows(odf);
	odf_startRow(odf,0);
	for(c=0;c<3;c++){
		sprintf(st,"Kopf %d",c);
		odf_writeCell(odf,st,1,0);
	}
	odf_endRow(odf);
	odtEndTableHeaderRow(odf);

	for(r=0;r<10;r++){
		odf_startRow(odf,0);
		for(c=0;c<3;c++){
			sprintf(st,"Zelle %d,%d",c,r);
			odf_writeCell(odf,st,2,r+2);	/* cellStyle, paragraphStyle */
		}
		odf_endRow(odf);
	}
	odf_endTable(odf);
	odf_writeParagraph(odf,"",0);
	odf_writeParagraph(odf,"Fertig!",0);
	odt_endDoc(odf);
	if(odf) odf_close(odf);

	return 0;
}
